'use strict'
var __assign =
  (this && this.__assign) ||
  function () {
    __assign =
      Object.assign ||
      function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i]
          for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p]
        }
        return t
      }
    return __assign.apply(this, arguments)
  }
var __awaiter =
  (this && this.__awaiter) ||
  function (thisArg, _arguments, P, generator) {
    function adopt(value) {
      return value instanceof P
        ? value
        : new P(function (resolve) {
            resolve(value)
          })
    }
    return new (P || (P = Promise))(function (resolve, reject) {
      function fulfilled(value) {
        try {
          step(generator.next(value))
        } catch (e) {
          reject(e)
        }
      }
      function rejected(value) {
        try {
          step(generator['throw'](value))
        } catch (e) {
          reject(e)
        }
      }
      function step(result) {
        result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected)
      }
      step((generator = generator.apply(thisArg, _arguments || [])).next())
    })
  }
var __generator =
  (this && this.__generator) ||
  function (thisArg, body) {
    var _ = {
        label: 0,
        sent: function () {
          if (t[0] & 1) throw t[1]
          return t[1]
        },
        trys: [],
        ops: [],
      },
      f,
      y,
      t,
      g
    return (
      (g = { next: verb(0), throw: verb(1), return: verb(2) }),
      typeof Symbol === 'function' &&
        (g[Symbol.iterator] = function () {
          return this
        }),
      g
    )
    function verb(n) {
      return function (v) {
        return step([n, v])
      }
    }
    function step(op) {
      if (f) throw new TypeError('Generator is already executing.')
      while (_)
        try {
          if (
            ((f = 1),
            y &&
              (t = op[0] & 2 ? y['return'] : op[0] ? y['throw'] || ((t = y['return']) && t.call(y), 0) : y.next) &&
              !(t = t.call(y, op[1])).done)
          )
            return t
          if (((y = 0), t)) op = [op[0] & 2, t.value]
          switch (op[0]) {
            case 0:
            case 1:
              t = op
              break
            case 4:
              _.label++
              return { value: op[1], done: false }
            case 5:
              _.label++
              y = op[1]
              op = [0]
              continue
            case 7:
              op = _.ops.pop()
              _.trys.pop()
              continue
            default:
              if (!((t = _.trys), (t = t.length > 0 && t[t.length - 1])) && (op[0] === 6 || op[0] === 2)) {
                _ = 0
                continue
              }
              if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                _.label = op[1]
                break
              }
              if (op[0] === 6 && _.label < t[1]) {
                _.label = t[1]
                t = op
                break
              }
              if (t && _.label < t[2]) {
                _.label = t[2]
                _.ops.push(op)
                break
              }
              if (t[2]) _.ops.pop()
              _.trys.pop()
              continue
          }
          op = body.call(thisArg, _)
        } catch (e) {
          op = [6, e]
          y = 0
        } finally {
          f = t = 0
        }
      if (op[0] & 5) throw op[1]
      return { value: op[0] ? op[1] : void 0, done: true }
    }
  }
Object.defineProperty(exports, '__esModule', { value: true })
exports.OpenAPIRoute = exports.route = void 0
var parameters_1 = require('./parameters')
function route(options, func) {
  func.schema = options
  return func
}
exports.route = route
var OpenAPIRoute = /** @class */ (function () {
  function OpenAPIRoute() {}
  OpenAPIRoute.getSchema = function () {
    return this.schema
  }
  Object.defineProperty(OpenAPIRoute.prototype, 'schema', {
    get: function () {
      // @ts-ignore
      return this.__proto__.constructor.schema
    },
    enumerable: false,
    configurable: true,
  })
  OpenAPIRoute.prototype.getSchema = function () {
    // @ts-ignore
    return this.__proto__.constructor.getSchema()
  }
  OpenAPIRoute.getParsedSchema = function () {
    var schema = this.getSchema()
    var requestBody = null
    if (schema.requestBody) {
      requestBody = new parameters_1.Body(schema.requestBody).getValue()
    }
    var responses = {}
    if (schema.responses) {
      for (var _i = 0, _a = Object.entries(schema.responses); _i < _a.length; _i++) {
        var _b = _a[_i],
          key = _b[0],
          value = _b[1]
        responses[key] = new parameters_1.Resp(value.schema, {
          description: value.description,
        }).getValue()
      }
    }
    // Deep copy
    return __assign(
      __assign(__assign({}, schema), {
        parameters: schema.parameters ? (0, parameters_1.getFormatedParameters)(schema.parameters) : {},
        responses: responses,
      }),
      requestBody ? { requestBody: requestBody } : {}
    )
  }
  OpenAPIRoute.prototype.jsonResp = function (params) {
    return new Response(JSON.stringify(params.data), {
      headers: {
        'content-type': 'application/json;charset=UTF-8',
      },
      status: params.status || 200,
    })
  }
  OpenAPIRoute.prototype.handleValidationError = function (errors) {
    return this.jsonResp({
      data: {
        errors: errors,
        success: false,
        result: {},
      },
      status: 400,
    })
  }
  OpenAPIRoute.prototype.execute = function () {
    var args = []
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i]
    }
    return __awaiter(this, void 0, void 0, function () {
      var _a, data, errors, resp
      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            return [4 /*yield*/, this.validateRequest(args[0])]
          case 1:
            ;(_a = _b.sent()), (data = _a.data), (errors = _a.errors)
            if (Object.keys(errors).length > 0) {
              return [2 /*return*/, this.handleValidationError(errors)]
            }
            args.push(data)
            return [4 /*yield*/, this.handle.apply(this, args)]
          case 2:
            resp = _b.sent()
            if (!(resp instanceof Response) && typeof resp === 'object') {
              return [2 /*return*/, this.jsonResp({ data: resp })]
            }
            return [2 /*return*/, resp]
        }
      })
    })
  }
  OpenAPIRoute.prototype.validateRequest = function (request) {
    return __awaiter(this, void 0, void 0, function () {
      var params,
        requestBody,
        queryParams,
        validatedObj,
        validationErrors,
        _i,
        _a,
        _b,
        key,
        value,
        param,
        name,
        rawData,
        json
      return __generator(this, function (_c) {
        switch (_c.label) {
          case 0:
            params = this.getSchema().parameters || {}
            requestBody = this.getSchema().requestBody
            queryParams = (0, parameters_1.extractQueryParameters)(request)
            validatedObj = {}
            validationErrors = {}
            for (_i = 0, _a = Object.entries(params); _i < _a.length; _i++) {
              ;(_b = _a[_i]), (key = _b[0]), (value = _b[1])
              param = value
              name = param.params.name ? param.params.name : key
              rawData = (0, parameters_1.extractParameter)(request, queryParams, name, param.location)
              try {
                validatedObj[name] = param.validate(rawData)
              } catch (e) {
                validationErrors[name] = e.message
              }
            }
            if (!(request.method.toLowerCase() !== 'get' && requestBody)) return [3 /*break*/, 2]
            return [4 /*yield*/, request.json()]
          case 1:
            json = _c.sent()
            try {
              validatedObj['body'] = new parameters_1.Body(requestBody).validate(json)
            } catch (e) {
              validationErrors['body' + e.key] = e.message
            }
            _c.label = 2
          case 2:
            return [
              2 /*return*/,
              {
                data: validatedObj,
                errors: validationErrors,
              },
            ]
        }
      })
    })
  }
  OpenAPIRoute.prototype.handle = function () {
    var args = []
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i]
    }
    throw new Error('Method not implemented.')
  }
  OpenAPIRoute.isRoute = true
  OpenAPIRoute.schema = null
  return OpenAPIRoute
})()
exports.OpenAPIRoute = OpenAPIRoute
